var data = new Array(); 

function Item() {
  this.codes = new Array(); 
  this.form = ""; 
  this.diff = ""; 
  this.timed = "";
  this.index = "";
  this.type = ""; 
  this.order = "";
  this.file = "";
  this.title = "";
}

function init() {
	if (elem("formForm").addEventListener){
		elem("formForm").addEventListener('click',formReset,false);
		elem("diffForm").addEventListener('click',diffReset,false);
		elem("timeForm").addEventListener('click',timeReset,false);
	} else {
		elem("formForm").attachEvent('click',formReset);
		elem("diffForm").attachEvent('click',diffReset);
		elem("timeForm").attachEvent('click',timeReset);
	}
      for (var i = 0; i < metadata.length; i++) {// načtení pojmů
        var item = new Item();
        item.codes = metadata[i][0];
        item.form = metadata[i][1];
        item.diff = metadata[i][2];
        item.timed = metadata[i][3];
        item.index = metadata[i][4];
        item.type = metadata[i][5];
        item.order = metadata[i][6];
        item.file = metadata[i][7];
        item.title = metadata[i][8];
        data.push(item);
      }
      createDb();
}

function createDb(inputData) {
    if (inputData == undefined) inputData = data;
    if (inputData.length == 0) {
        setHTML("resultsHeader", ("Počet zobrazených záznamů: 0/" + data.length));
        setHTML("results", "Žádna položka nesplňuje zadaná kritéria");
        return;
    }
    var sb = new StringBuffer();
    for (var i = 0; i < inputData.length; i++) {
        sb.append(createItem(inputData[i], i));
    }
    setHTML("resultsHeader", ("Počet zobrazených záznamů: " + inputData.length + "/" + data.length));
    setHTML("results", sb.toString());
}

function createCodeString(item) {
    var codeString = "";
    for (var ind = 0; ind < 4; ind++) {
        if (ind < item.codes.length) {
            codeString += item.codes[ind];
       } else {
               codeString += "---";
       }
    }
    codeString += item.form + item.diff + item.timed + item.index;
    return codeString;
}

function createItem(item, i) {
    var sb = new StringBuffer();
    var codeString = createCodeString(item);
    sb.append("<div class='item ");
    sb.append((i % 2) == 1 ? "li' >" : "li2' >");
        sb.append("<div style='float: left'><strong>" + item.order + ". " + item.title
        + "</strong>  <span style='color: #ccc; font-style:'></span><br />");
            sb.append("<span>&nbsp;zadání: </span>");
            sb.append("<a href='files/" + item.file + "z.doc' target='_blank'>.doc</a> ");
            sb.append("&nbsp;<span style='color:#bbb;'>|</span>&nbsp;<a href='files/" + item.file + "z.pdf' target='_blank'>.pdf</a>");
            sb.append("<br /><span>&nbsp;řešení: </span>");
            sb.append("<a href='files/" + item.file + "r.doc' target='_blank'>.doc</a> ");
            sb.append("&nbsp;<span style='color:#bbb;'>|</span>&nbsp;<a href='files/" + item.file + "r.pdf' target='_blank'>.pdf</a>");
        sb.append("</div>");
        sb.append("<div>");
        sb.append("<div style='text-align: right;'>");
        sb.append(codeString);
        sb.append("</div><div>");
        if (codeString.indexOf("Ch") != -1) {
            sb.append(" <img src='img/img_ch.png' title='Chemie' alt='Chemie' width='22' height='32' class='climg' />");
        }
        if (codeString.indexOf("Z") != -1) {
            sb.append(" <img src='img/img_z.png' title='Geografie' alt='Geografie' width='24' height='32' class='climg' />");
        }
        if (codeString.indexOf("P") != -1) {
            sb.append(" <img src='img/img_p.png' title='Přírodopis' alt='Přírodopis' width='18' height='32' class='climg' />");
        }
        if (codeString.indexOf("F") != -1) {
            sb.append(" <img src='img/img_f.png' title='Fyzika' alt='Fyzika' width='26' height='32' class='climg' />");
        }
        if (codeString.indexOf("M") != -1) {
            sb.append(" <img src='img/img_m.png' title='Matematika' alt='Matematika' width='29' height='32' class='climg' />");
        }
        if (codeString.lastIndexOf("d") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_d_list.png' title='Doplňovačka' alt='Doplňovačka' width='65' height='22' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("h") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_h_list.png' title='Hřebenovka' alt='Hřebenovka' width='64' height='20' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("r") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_r_list.png' title='Roháček' alt='Roháček' width='24' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("b") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_b_list.png' title='Buňkovka' alt='Buňkovka' width='28' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("k") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_k_list.png' title='Kruh' alt='Kruh' width='32' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("o") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_o_list.png' title='Osmisměrka' alt='Osmisměrka' width='14' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("l") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_l_list.png' title='Lištovka' alt='Lištovka' width='49' height='24' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("p") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_p_list.png' title='Přeskupovačka' alt='Přeskupovačka' width='15' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("s") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_s_list.png' title='Šifra a rébus' alt='Šifra a rébus' width='39' height='24' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("q") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_q_list.png' title='Chemický otazník' alt='Chemický otazník' width='24' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("t") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_t_list.png' title='Chemický text' alt='Chemický text' width='54' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("z") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_z_list.png' title='Zebra' alt='Zebra' width='36' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("e") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_e_list.png' title='Efektní pokus' alt='Efektní pokus' width='30' height='32' class='climg' /></span>");
        }
        if (codeString.lastIndexOf("m") == 13) {
            sb.append("&nbsp;|&nbsp;<span style='width:65px;text-align:center;display:inline-block;'><img src='img/logo_m_list.png' title='Chemická mikrodetektivka' alt='Chemická mikrodetektivka' width='30' height='32' class='climg' /></span>");
        }
        if (item.timed == "05") {
            sb.append(" | <strong>&nbsp;&nbsp;5&nbsp;min</strong>");
        } else {
            if (item.timed == "99") {
                sb.append("&nbsp;|&nbsp;<strong>neomezeně</strong>");
            } else {
                sb.append("&nbsp;|&nbsp;<strong>" + item.timed + "&nbsp;min</strong>");
            }
        }
        sb.append("</div></div><div class='cl'></div>");
    sb.append("</div>");
    return sb.toString();
}

function listCodes(codes) {
    var sb = new StringBuffer();
    for (var i = 0; i < codes.length; i++) {
        sb.append(codes[i] + " ");
    }
    return sb.toString();
}

function toggleParts() {
    var head = elem("headerPart").style;
    var filt = elem("filterPart").style;
    if (head.display == "block") {
        filt.display = "block";
        head.display = "none";
    } else {
        head.display = "block";
        filt.display = "none";
    }
}

function toggle(nodeId, tem) {
    var item = elem(nodeId + "_sub");
    var value = false
    if (item.style.display == "none") {
        item.style.display = "block";
        value = true;
    } else {
        item.style.display = "none";
        var checkers = item.getElementsByTagName("input");
        for (var i = 0; i < checkers.length; i++) {
            checkers[i].checked = false;
        }
    }
    if (!tem) {
         toggleDisplay(nodeId, value);
    } else {
        elem(nodeId).checked = value;
    }
}


function applyCodeFilter() {
    var results = new Array();
    var clear =new RegExp("-","g");
    var codeString = getValue("code").replace(clear, "").toLowerCase();
    var itemString;
    for (var i = 0; i < data.length; i++) {
        itemString = createCodeString(data[i]).replace(clear, "").toLowerCase();
        if (itemString.indexOf(codeString) != -1) {
            results.push(data[i]);
        }
    }
    createDb(results);
}

function applyFilter() {
    alert("funkce applyFilter() není naprogramována!");
}

function filterByTheme() {
    var results = new Array();
    var filter = new Array();
    var topBoxes = elem("top-themes").getElementsByTagName("input");
    for (var i = 0; i < topBoxes.length; i++) {
        if (topBoxes[i].checked) {
            var topResult = topBoxes[i].id.charAt(0);
            if (topResult == "x") topResult = "ch";
            var childChecked = false;
            var idx = 1;
            var node = elem(topResult + idx );
            while (node != null) {
                var leavesChecked = false;
                if (node.checked) {
                    childChecked = true;
                    var leaves = elem(node.id + "_lvl_sub").getElementsByTagName("input");
                    for (var x = 0; x < leaves.length; x++) {
                        if (leaves[x].checked) {
                            filter.push(leaves[x].id);
                            leavesChecked = true
                        }
                    }
                    if (!leavesChecked) filter.push(node.id);
                }
                node = elem(topResult + (++idx));
            }
            if (!childChecked) filter.push(topResult);
        }
    }
    if (filter.length == 0) return data;
    for (var i = 0; i < data.length; i++) {
        var codes = data[i].codes;
        for (var j = 0; j < codes.length; j++) {
            var inserted = false;
            for (var k = 0; k < filter.length; k++) {
                if (codes[j].toLowerCase().indexOf(filter[k]) > -1) {
                    results.push(data[i]);
                    inserted = true;
                    break;
                }
            }
            if (inserted) break;
        }
    }
    return results;
}

function filterByForm(inputData) {
    if (inputData == undefined) inputData = data;
    if (elem("form_All").checked) {
        return inputData;
    }
    var filter = new Array();
    var results = new Array();
    var id;
    var i;
    var checkers = elem("formForm").getElementsByTagName("input");
    for (i = 0; i < checkers.length; i++) {
        if (checkers[i].checked) {
            id = checkers[i].id;
            filter.push(id.substring(id.indexOf("_") + 1));
        }
    }
    for (i = 0; i < inputData.length; i++) {
        for (var j = 0; j < filter.length; j++) {
            if (inputData[i].form == filter[j]) {
                results.push(inputData[i]);
            }
        }
    }
    return results;
}

function filterByDiff(inputData) {
    if (inputData == undefined) inputData = data;
    if (elem("diff_All").checked) {
        return inputData;
    }
    var filter = new Array();
    var results = new Array();
    var id;
    var i;
    var checkers = elem("diffForm").getElementsByTagName("input");
    for (i = 0; i < checkers.length; i++) {
        if (checkers[i].checked) {
            id = checkers[i].id;
            filter.push(id.substring(id.indexOf("_") + 1));
        }
    }
    for (i = 0; i < inputData.length; i++) {
        for (var j = 0; j < filter.length; j++) {
            if (inputData[i].diff == filter[j]) {
                results.push(inputData[i]);
            }
        }
    }
    return results;
}

function filterByTime(inputData) {
    if (inputData == undefined) inputData = data;
    if (elem("time_All").checked) {
        return inputData;
    }
    var filter = new Array();
    var results = new Array();
    var id;
    var i;
    var checkers = elem("timeForm").getElementsByTagName("input");
    for (i = 0; i < checkers.length; i++) {
        if (checkers[i].checked) {
            id = checkers[i].id;
            filter.push(id.substring(id.indexOf("_") + 1));
        }
    }
    for (i = 0; i < inputData.length; i++) {
        for (var j = 0; j < filter.length; j++) {
            if (inputData[i].timed == filter[j]) {
                results.push(inputData[i]);
            }
        }
    }
    return results;
}

function formReset() { filterReset("form")}
function diffReset() { filterReset("diff")}
function timeReset() { filterReset("time")}

function filterReset(type) {
    var ch = elem(type + "Form").getElementsByTagName("input");
    var noneSel = false;
    for (var i = 0; i < (ch.length-1); i++) {
        if (ch[i].checked) return;
    }
    elem(type + "_All").checked = "checked";
}

function filterForm(type, selectAll) {
    if (selectAll) {
        var formTable = elem(type + "Form");
        var checkers = formTable.getElementsByTagName("input");
        for (var i = 0; i < checkers.length; i++) {
            var id = checkers[i].id;
            if (checkers[i].checked) checkers[i].checked = false;
        }
        elem(type + "_All").checked = "checked";
        return;
    }
    if (elem(type + "_All").checked) elem(type + "_All").checked = false;
}

function resetAll() {
    var toolbar = elem("filterToolbar");
    var checkers = toolbar.getElementsByTagName("input");
    for (var i = 0; i < checkers.length; i++) {
        var id = checkers[i].id;
        if (id == "xem" || id == "zem") {
            var subcelok = id + "_sub";
            elem(subcelok).style.display = "none";
        }
        var max = 2;
        if (id.indexOf("ch") != -1) max = 3;
        if (id.length == max) {
            var subcelok = id + "_lvl_sub";
            elem(subcelok).style.display = "none";
        }
        if (checkers[i].checked) checkers[i].checked = false;
    }
    elem("form_All").checked = "checked";
    elem("diff_All").checked = "checked";
    elem("time_All").checked = "checked";
    elem("code").value = "";
    createDb();
}

function StringBuffer() {
  this.buffer = [];
}

StringBuffer.prototype.append = function append(string) {
  this.buffer.push(string);
  return this;
};

StringBuffer.prototype.toString = function toString() {
  return this.buffer.join("");
};

function getValue(nodeId) {
  return document.getElementById(nodeId).value;
}

function setHTML(nodeId, retez) {
  document.getElementById(nodeId).innerHTML = retez;
}

function elem(id) {
  return document.getElementById(id);
}

function toggleDisplay(nodeId, value) {
    elem(nodeId).firstChild.nextSibling.checked = value;
}

Array.prototype.isLast = function(retez) {
  if (this.length == 0) return false;
  else {
    if (this[this.length-1] == retez) return true;
    else return false;
  }
};
